﻿using System;
using System.Collections.Generic;
using System.Text;
using jp.nyatla.nyartoolkit.cs.core;
using Microsoft.WindowsMobile.DirectX.Direct3D;
using Microsoft.WindowsMobile.DirectX;
using NyARToolkitCSUtils.Direct3d;
using System.Xml;
namespace ARDemo
{
    public class XmlHelper
    {
        public static bool getAttrValue(XmlNode i_node, String i_path, bool i_default)
        {
            XmlNode n = i_node.SelectSingleNode(i_path);
            return n == null ? i_default : bool.Parse(n.Value);
        }
        public static float getAttrValue(XmlNode i_node, String i_path, float i_default)
        {
            XmlNode n = i_node.SelectSingleNode(i_path);
            return n == null ? i_default : float.Parse(n.Value);
        }
        public static String getAttrValue(XmlNode i_node, String i_path, String i_default)
        {
            XmlNode n = i_node.SelectSingleNode(i_path);
            return n == null ? i_default : n.Value;
        }
    }

    public class XYZAttr
    {
        public float x, y, z;
        public static XYZAttr createInstance(XmlNode i_node)
        {
            if (i_node == null)
            {
                return null;
            }
            XYZAttr inst = new XYZAttr();
            inst.x = XmlHelper.getAttrValue(i_node, "@x", 0.0f);
            inst.y = XmlHelper.getAttrValue(i_node, "@y", 0.0f);
            inst.z = XmlHelper.getAttrValue(i_node, "@z", 0.0f);
            return inst;
        }

    }
    public class RotateNode
    {
        const float PI2 = (float)(Math.PI * 2.0);
        public XYZAttr rotate;
        private float rx, ry, rz;
        public static RotateNode createInstance(XmlNode i_rotate_node)
        {
            if (i_rotate_node == null)
            {
                return null;
            }
            RotateNode inst = new RotateNode();
            inst.rotate = XYZAttr.createInstance(i_rotate_node.SelectSingleNode("step"));
            //度→radian変換
            inst.rotate.x = (float)(inst.rotate.x * Math.PI / 180.0);
            inst.rotate.y = (float)(inst.rotate.y * Math.PI / 180.0);
            inst.rotate.z = (float)(inst.rotate.z * Math.PI / 180.0);
            inst.rx = inst.ry = inst.rz = 0.0f;
            return inst;
        }
        public void multMatrix(ref Matrix i_base_mat)
        {
            if (this.rotate != null)
            {
                rx = (rx + this.rotate.x) % PI2;
                ry = (ry + this.rotate.y) % PI2;
                rz = (rz + this.rotate.z) % PI2;
                i_base_mat *= Matrix.RotationYawPitchRoll(rx, ry, rz);
            }
            return;
        }
    }
    public class ModelLoader
    {
        public static DsSingleARMarkerApplication.IDisplayObject loadFromXML(D3dManager i_d3dmgr, String i_xml_path)
        {
            XmlDocument dom = new XmlDocument();

            //ファイル名の確定
            dom.Load(i_xml_path);
            String xml_dir = System.IO.Path.GetDirectoryName(i_xml_path);
            String version = dom.SelectSingleNode("/root/version").InnerText;
            switch (version)
            {
                case "AnimationModel/0.1":
                    return new AnimationModel(i_d3dmgr, dom, xml_dir);
                case "StaticModel/0.1":
                    return new StaticModel(i_d3dmgr, dom, xml_dir);
                /*  ここに追加してください。
                 */
                default:
                    throw new Exception("未知の/root/version");
            }
        }
    }

}